Index: /LMDZ6/trunk/libf/phylmd/compbl_mod_h.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/compbl_mod_h.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/compbl_mod_h.f90	(revision 5627)
@@ -3,5 +3,5 @@
 MODULE compbl_mod_h
   IMPLICIT NONE; PRIVATE
-  PUBLIC iflag_pbl, iflag_pbl_split, iflag_order2_sollw, ifl_pbltree
+  PUBLIC iflag_pbl, iflag_pbl_split, iflag_order2_sollw, ifl_pbltree, iflag_hetero_surf
 
   !!      integer iflag_pbl,iflag_pbl_split
@@ -9,6 +9,6 @@
   !!FC      integer iflag_pbl, iflag_pbl_split, iflag_order2_sollw
   !FC      common/compbl/iflag_pbl, iflag_pbl_split, iflag_order2_sollw
-  INTEGER iflag_pbl, iflag_pbl_split, iflag_order2_sollw, ifl_pbltree
-  !$OMP THREADPRIVATE(iflag_pbl, iflag_pbl_split, iflag_order2_sollw, ifl_pbltree)
+  INTEGER iflag_pbl, iflag_pbl_split, iflag_order2_sollw, ifl_pbltree, iflag_hetero_surf
+  !$OMP THREADPRIVATE(iflag_pbl, iflag_pbl_split, iflag_order2_sollw, ifl_pbltree, iflag_hetero_surf)
 
   !>jyg+al1
Index: /LMDZ6/trunk/libf/phylmd/conf_phys_m.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/conf_phys_m.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/conf_phys_m.f90	(revision 5627)
@@ -193,4 +193,6 @@
     REAL,SAVE :: Cd_frein_omp
 !FC
+!AM
+    INTEGER,SAVE :: iflag_hetero_surf_omp
     INTEGER,SAVE :: iflag_order2_sollw_omp
     INTEGER, SAVE :: lev_histins_omp, lev_histLES_omp 
@@ -1531,5 +1533,12 @@
     Cd_frein_omp = 7.5E-02
     CALL getin('Cd_frein',Cd_frein_omp)
-
+!AM
+    !Config Key  = iflag_hetero_surf
+    !Config Desc = type of treatment for heterogeneous continental sub-surfaces
+    !Config Def  = 0
+    !Config Help = 0: homo. surface; 1: heteo. surface with parameter aggregation; 2: heteo surface with flux aggregation
+    !
+    iflag_hetero_surf_omp = 0
+    CALL getin('iflag_hetero_surf',iflag_hetero_surf_omp)
     !
     !Config Key  = iflag_pbl_split
@@ -2390,4 +2399,6 @@
     ifl_pbltree = ifl_pbltree_omp
     Cd_frein    =Cd_frein_omp
+!AM
+    iflag_hetero_surf = iflag_hetero_surf_omp
     iflag_order2_sollw = iflag_order2_sollw_omp
     lev_histhf = lev_histhf_omp
@@ -2839,4 +2850,6 @@
     WRITE(lunout,*) ' ifl_pbltree = ', ifl_pbltree
     WRITE(lunout,*) ' Cd_frein = ', Cd_frein
+!AM
+    WRITE(lunout,*) ' iflag_hetero_surf = ', iflag_hetero_surf
     WRITE(lunout,*) ' iflag_pbl_split = ', iflag_pbl_split
     WRITE(lunout,*) ' iflag_order2_sollw = ', iflag_order2_sollw
Index: /LMDZ6/trunk/libf/phylmd/dimphy.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/dimphy.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/dimphy.f90	(revision 5627)
@@ -12,4 +12,6 @@
   INTEGER,SAVE :: klevm1
   INTEGER,SAVE :: kflev
+  INTEGER,SAVE :: nbtersrf !AM
+  INTEGER,SAVE :: nbtsoildepths !AM
 
 !$OMP THREADPRIVATE(klon,kfdia,kidia,kdlon)
@@ -44,5 +46,5 @@
   END SUBROUTINE Init_dimphy
 
-  SUBROUTINE Init_dimphy1D(klon0,klev0)
+  SUBROUTINE Init_dimphy1D(klon0,klev0,nbtersrf0,nbtsoildepths0)
 ! 1D special version of dimphy without ALLOCATE(zmasq)
 ! which will be allocated in iniphysiq
@@ -51,5 +53,7 @@
     INTEGER, INTENT(in) :: klon0
     INTEGER, INTENT(in) :: klev0
-    
+    INTEGER, INTENT(in), OPTIONAL :: nbtersrf0
+    INTEGER, INTENT(in), OPTIONAL :: nbtsoildepths0
+
     klon=klon0
     kdlon=klon
@@ -60,5 +64,7 @@
     klevm1=klev-1
     kflev=klev
-    
+    nbtersrf=nbtersrf0
+    nbtsoildepths=nbtsoildepths0
+
   END SUBROUTINE Init_dimphy1D
 
Index: /LMDZ6/trunk/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- /LMDZ6/trunk/libf/phylmd/dyn1d/1DUTILS.h	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/dyn1d/1DUTILS.h	(revision 5627)
@@ -415,4 +415,102 @@
        CALL getin('tau_soil_nudge',tau_soil_nudge)
 
+!Config  Key  = nb_ter_srf
+!Config  Desc = nb_ter_srf
+!Config  Def  = 0
+!Config  Help =
+       nb_ter_srf = 0
+       CALL getin('nb_ter_srf',nb_ter_srf)
+
+!Config  Key  = alpha_soil_ter_srf
+!Config  Desc = alpha_soil_ter_srf
+!Config  Def  = 2.
+!Config  Help =
+       alpha_soil_ter_srf = 2.
+       CALL getin('alpha_soil_ter_srf',alpha_soil_ter_srf)
+
+!Config  Key  = period_ter_srf
+!Config  Desc = period_ter_srf
+!Config  Def  = 1800.
+!Config  Help =
+       period_ter_srf = 1800.
+       CALL getin('period_ter_srf',period_ter_srf)
+
+!Config  Key  = frac_ter_srf
+!Config  Desc = frac_ter_srf
+!Config  Def  = 0.
+!Config  Help = 
+       frac_ter_srf = 0.
+       CALL getin('frac_ter_srf',frac_ter_srf)
+
+!Config  Key  = rugos_ter_srf
+!Config  Desc = rugos_ter_srf
+!Config  Def  = 0.
+!Config  Help = 
+       rugos_ter_srf = 0.
+       CALL getin('rugos_ter_srf',rugos_ter_srf)
+
+!Config  Key  = ratio_z0m_z0h_ter_srf
+!Config  Desc = ratio_z0m_z0h_ter_srf
+!Config  Def  = 10.
+!Config  Help = 
+       ratio_z0m_z0h_ter_srf = 10.
+       CALL getin('ratio_z0m_z0h_ter_srf',ratio_z0m_z0h_ter_srf)
+
+!Config  Key  = albedo_ter_srf
+!Config  Desc = albedo_ter_srf
+!Config  Def  = 0.
+!Config  Help = 
+       albedo_ter_srf = 0.
+       CALL getin('albedo_ter_srf',albedo_ter_srf)
+
+!Config  Key  = beta_ter_srf
+!Config  Desc = beta_ter_srf
+!Config  Def  = 0.
+!Config  Help = 
+       beta_ter_srf = 0.
+       CALL getin('beta_ter_srf',beta_ter_srf)
+
+!Config  Key  = inertie_ter_srf
+!Config  Desc = inertie_ter_srf
+!Config  Def  = 0.
+!Config  Help = 
+       inertie_ter_srf = 0.
+       CALL getin('inertie_ter_srf',inertie_ter_srf)
+
+!Config  Key  = hcond_ter_srf
+!Config  Desc = hcond_ter_srf
+!Config  Def  = 0.
+!Config  Help =
+       hcond_ter_srf = 0.
+       CALL getin('hcond_ter_srf',hcond_ter_srf)
+
+!Config  Key  = tsurf_ter_srf
+!Config  Desc = tsurf_ter_srf
+!Config  Def  = 283.
+!Config  Help =
+       tsurf_ter_srf = 283.
+       CALL getin('tsurf_ter_srf',tsurf_ter_srf)
+
+!Config  Key  = tsoil_ter_srf
+!Config  Desc = tsoil_ter_srf
+!Config  Def  = 283.
+!Config  Help =
+       tsoil_ter_srf = 283.
+       CALL getin('tsoil_ter_srf',tsoil_ter_srf)
+
+!Config  Key  = tsoil_depths
+!Config  Desc = tsoil_depths
+!Config  Def  = 0.
+!Config  Help =
+       tsoil_depths = 0.
+       CALL getin('tsoil_depths',tsoil_depths)
+
+!Config  Key  = nb_tsoil_depths
+!Config  Desc = nb_tsoil_depths
+!Config  Def  = 0
+!Config  Help =
+       nb_tsoil_depths = 0
+       CALL getin('nb_tsoil_depths',nb_tsoil_depths)
+
 !----------------------------------------------------------
 ! Param??tres de for??age pour les forcages communs:
@@ -631,4 +729,17 @@
       write(lunout,*)' nudging_t  = ', nudging_t
       write(lunout,*)' nudging_qv  = ', nudging_qv
+      write(lunout,*)' nb_ter_srf = ', nb_ter_srf
+      write(lunout,*)' alpha_soil_ter_srf = ', alpha_soil_ter_srf
+      write(lunout,*)' period_ter_srf = ', period_ter_srf 
+      write(lunout,*)' frac_ter_srf = ', frac_ter_srf
+      write(lunout,*)' rugos_ter_srf = ', rugos_ter_srf
+      write(lunout,*)' ratio_z0m_z0h_ter_srf = ', ratio_z0m_z0h_ter_srf
+      write(lunout,*)' albedo_ter_srf = ', albedo_ter_srf
+      write(lunout,*)' beta_ter_srf = ', beta_ter_srf
+      write(lunout,*)' inertie_ter_srf = ', inertie_ter_srf
+      write(lunout,*)' hcond_ter_srf = ', hcond_ter_srf
+      write(lunout,*)' tsurf_ter_srf = ', tsurf_ter_srf
+      write(lunout,*)' tsoil_ter_srf = ', tsoil_ter_srf
+
       IF (forcing_type .eq.40) THEN
         write(lunout,*) '--- Forcing type GCSS Old --- with:'
Index: /LMDZ6/trunk/libf/phylmd/dyn1d/compar1d_mod_h.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/dyn1d/compar1d_mod_h.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/dyn1d/compar1d_mod_h.f90	(revision 5627)
@@ -8,4 +8,8 @@
           iflag_nudge, snowmass, &
           restart, ok_old_disvert, &
+          nb_ter_srf, alpha_soil_ter_srf, period_ter_srf, frac_ter_srf, &
+          rugos_ter_srf, ratio_z0m_z0h_ter_srf, albedo_ter_srf, beta_ter_srf, &
+          inertie_ter_srf, hcond_ter_srf, tsurf_ter_srf, tsoil_ter_srf, &
+          tsoil_depths, nb_tsoil_depths, &
           tadv, tadvv, tadvh, qadv, qadvv, qadvh, thadv, thadvv, thadvh, &
           trad, forc_omega, forc_u, forc_v, forc_w, forc_geo, forc_ustar, &
@@ -44,4 +48,19 @@
   LOGICAL :: ok_old_disvert
 
+  INTEGER :: nb_ter_srf
+  REAL :: alpha_soil_ter_srf
+  REAL :: period_ter_srf
+  REAL, DIMENSION(5) :: frac_ter_srf
+  REAL, DIMENSION(5) :: rugos_ter_srf
+  REAL, DIMENSION(5) :: ratio_z0m_z0h_ter_srf
+  REAL, DIMENSION(5) :: albedo_ter_srf
+  REAL, DIMENSION(5) :: beta_ter_srf
+  REAL, DIMENSION(5) :: inertie_ter_srf
+  REAL, DIMENSION(5) :: hcond_ter_srf
+  REAL, DIMENSION(5) :: tsurf_ter_srf
+  REAL, DIMENSION(5*5) :: tsoil_ter_srf
+  REAL, DIMENSION(5*5) :: tsoil_depths
+  INTEGER :: nb_tsoil_depths
+
   ! Pour les forcages communs: ces entiers valent 0 ou 1
   ! tadv= advection tempe, tadvv= adv tempe verticale, tadvh= adv tempe horizontale
@@ -65,4 +84,8 @@
   !$OMP      iflag_nudge, snowmass, &
   !$OMP      restart, ok_old_disvert, &
+  !$OMP      nb_ter_srf, frac_ter_srf, rugos_ter_srf, albedo_ter_srf,         &
+  !$OMP      beta_ter_srf, inertie_ter_srf, alpha_soil_ter_srf,               &
+  !$OMP      period_ter_srf, hcond_ter_srf, ratio_z0m_z0h_ter_srf,            &
+  !$OMP      tsurf_ter_srf, tsoil_ter_srf, tsoil_depths, nb_tsoil_depths,     &
   !$OMP      tadv, tadvv, tadvh, qadv, qadvv, qadvh, thadv, thadvv, thadvh, &
   !$OMP      trad, forc_omega, forc_u, forc_v, forc_w, forc_geo, forc_ustar, &
Index: /LMDZ6/trunk/libf/phylmd/dyn1d/scm.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/dyn1d/scm.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/dyn1d/scm.f90	(revision 5627)
@@ -8,4 +8,8 @@
        clwcon, detr_therm, &
        qsol, fevap, z0m, z0h, agesno, &
+       frac_tersrf, z0m_tersrf, ratio_z0m_z0h_tersrf, &
+       albedo_tersrf, beta_tersrf, inertie_tersrf, &
+       alpha_soil_tersrf, period_tersrf, hcond_tersrf, &
+       tsurfi_tersrf, tsoili_tersrf, tsoil_depth, &
        du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
        falb_dir, falb_dif, &
@@ -178,4 +182,7 @@
       real :: fder(1),snsrf(1,nbsrf),qsurfsrf(1,nbsrf)
       real :: tsoil(1,nsoilmx,nbsrf)
+      ! AM
+      REAL, ALLOCATABLE, DIMENSION(:,:) :: tsoil_ter_srf2 ! resized initial soil temperature on vertical levels (K) 
+      REAL, ALLOCATABLE, DIMENSION(:,:) :: tsoil_depths2  ! resized soil depth at which inititial temperature is given (m)
 
 !---------------------------------------------------------------------
@@ -222,5 +229,6 @@
 !                           <> 0, tendencies of forcing are not added
       INTEGER :: flag_inhib_forcing = 0
-
+      CHARACTER(len=80) :: abort_message
+      CHARACTER(len=20) :: modname = 'scm'
 
       print*,'VOUS ENTREZ DANS LE 1D FORMAT STANDARD'
@@ -385,5 +393,5 @@
 !     call init_phys_lmdz(1,1,llm,1,(/1/)) ! job now done via iniphysiq
 !     but we still need to initialize dimphy module (klon,klev,etc.)  here.
-      call init_dimphy1D(1,llm)
+      call init_dimphy1D(1,llm,nb_ter_srf,nb_tsoil_depths)
       call suphel
       call init_infotrac
@@ -560,4 +568,48 @@
         agesno  = xagesno
         tsoil(:,:,:)=tsurf
+
+        iflag_hetero_surf = 0
+        CALL getin('iflag_hetero_surf',iflag_hetero_surf)
+
+        IF (iflag_hetero_surf .GT. 0) THEN
+          PRINT*, 'scm iflag_hetero_surf', iflag_hetero_surf
+          IF ((nbtersrf .LT. 2) .OR. (nbtersrf .GT. max_nbtersrf)) THEN
+            abort_message='The number of continental sub-surfaces (nb_ter_srf) must be between 2 and 5'
+            CALL abort_physic(modname,abort_message,1)
+          ENDIF
+          ! resized initial soil temperature on vertical levels and soil depth at which inititial temperature is given
+          ALLOCATE(tsoil_ter_srf2(nbtsoildepths,nbtersrf))
+          ALLOCATE(tsoil_depths2(nbtsoildepths,nbtersrf))
+          tsoil_ter_srf2(:,:) = 0.
+          tsoil_depths2(:,:) = 0.
+          DO i=1, nbtersrf
+            DO l=1, nbtsoildepths
+              k = nbtsoildepths*(i-1)+l
+              tsoil_ter_srf2(l,i) = tsoil_ter_srf(k)
+              tsoil_depths2(l,i) = tsoil_depths(k)
+            ENDDO
+          ENDDO
+          !
+          DO i=1, nbtersrf
+            frac_tersrf(:,i) = frac_ter_srf(i)                   ! fraction of land surface heterogeneity (-)
+            z0m_tersrf(:,i) = rugos_ter_srf(i)                   ! roughness length for momentum of land sub-surfaces (m)
+            ratio_z0m_z0h_tersrf(:,i) = ratio_z0m_z0h_ter_srf(i) ! ratio of heat to momentum roughness length of land sub-surfaces (-)
+            albedo_tersrf(:,i) = albedo_ter_srf(i)               ! albedo of land sub-surfaces (-)
+            beta_tersrf(:,i) = beta_ter_srf(i)                   ! evapotranspiration coef of land sub-surfaces (-)
+            inertie_tersrf(:,i) = inertie_ter_srf(i)             ! soil thermal inertia of land sub-surfaces (J/m2/K/s1/2)
+            hcond_tersrf(:,i) = hcond_ter_srf(i)                 ! soil heat conductivity (W/(m.K))
+            tsurfi_tersrf(:,i) = tsurf_ter_srf(i)                ! initial surface temperature (K)
+            DO l=1, nbtsoildepths
+              tsoili_tersrf(:,l,i) = tsoil_ter_srf2(l,i)         ! initial soil temperature on vertical levels (K)
+              tsoil_depth(:,l,i) = tsoil_depths2(l,i)
+            ENDDO
+          ENDDO
+          alpha_soil_tersrf = alpha_soil_ter_srf               ! ratio between the thicknesses of 2 successive layers (-)
+          period_tersrf = period_ter_srf                       ! temperature oscillation amplitude period
+          !
+          DEALLOCATE(tsoil_ter_srf2)
+          DEALLOCATE(tsoil_depths2)
+        ENDIF
+
 !-----------------------------------------------------------------------
         call pbl_surface_init(fder, snsrf, qsurfsrf, tsoil)
Index: /LMDZ6/trunk/libf/phylmd/indice_sol_mod.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/indice_sol_mod.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/indice_sol_mod.f90	(revision 5627)
@@ -14,4 +14,12 @@
            INTEGER, SAVE    :: nvm_orch ! Nombre de type de vegetation ds ORCHIDEE                 
            !$OMP THREADPRIVATE(nvm_orch)
+!
+!AM heterogeneous continental sub-surfaces
+            !!! If max_nbtersrf is modified, please change also the output number in phys_output_ctrlout_mod.F90
+            INTEGER, PARAMETER :: max_nbtersrf = 5  ! maximal number of continental sub-surfaces
+            CHARACTER(len=1), DIMENSION(max_nbtersrf), PARAMETER :: nb_tersrf = (/'1', '2', '3', '4', '5'/)
+            !!! nsoilout must be lower than nsoilmx
+            INTEGER, PARAMETER :: nsoilout = 10  ! number of soil layers for output
+            CHARACTER(len=2), DIMENSION(nsoilout), PARAMETER :: nb_soil = (/'01','02','03','04','05','06','07','08','09','10'/)!,'11','12','13','14'/)
 
       END MODULE indice_sol_mod
Index: /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 5627)
@@ -313,6 +313,10 @@
 !!        tke_x,     tke_w                              &
        wake_dltke,                                   &
-        treedrg                                      &
+        treedrg,                                      &
 !FC
+!AM heterogeneous continental sub-surfaces
+       tsurf_tersrf, tsoil_tersrf, qsurf_tersrf, tsurf_new_tersrf, &
+       cdragm_tersrf, cdragh_tersrf, &
+       swnet_tersrf, lwnet_tersrf, fluxsens_tersrf, fluxlat_tersrf &
 !!!
 #ifdef ISO
@@ -390,5 +394,13 @@
 ! pblT-----output-R- T au nveau HCL
 ! treedrg--output-R- tree drag (m)               
-!
+! qsurf_tersrf--output-R- surface specific humidity of continental sub-surfaces
+! cdragm_tersrf--output-R- momentum drag coefficient of continental sub-surfaces
+! cdragh_tersrf--output-R- heat drag coefficient of continental sub-surfaces
+! tsurf_new_tersrf--output-R- surface temperature of continental sub-surfaces
+! swnet_tersrf--output-R- net shortwave radiation of continental sub-surfaces
+! lwnet_tersrf--output-R- net longwave radiation of continental sub-surfaces
+! fluxsens_tersrf--output-R- sensible heat flux of continental sub-surfaces
+! fluxlat_tersrf--output-R- latent heat flux of continental sub-surfaces
+
     USE carbon_cycle_mod,   ONLY : carbon_cycle_cpl, carbon_cycle_tr, level_coupling_esm 
     USE carbon_cycle_mod,   ONLY : co2_send, nbcf_out, fields_out, yfields_out, cfname_out
@@ -414,5 +426,6 @@
     USE ioipsl_getin_p_mod, ONLY : getin_p
     use phys_state_var_mod, only: ds_ns, dt_ns, delta_sst, delta_sal, dter, &
-         dser, dt_ds, zsig, zmea
+         dser, dt_ds, zsig, zmea, &
+         frac_tersrf, z0m_tersrf, ratio_z0m_z0h_tersrf, albedo_tersrf !AM 
     use phys_output_var_mod, only: tkt, tks, taur, sss
     use lmdz_blowing_snow_ini, only : zeta_bs
@@ -420,4 +433,5 @@
     USE netcdf, only: missing_val_netcdf => nf90_fill_real
     USE dimsoil_mod_h, ONLY: nsoilmx
+    USE surf_param_mod, ONLY: eff_surf_param  !AM
 
     USE yomcst_mod_h
@@ -620,5 +634,16 @@
     REAL, DIMENSION(klon, klev, nbsrf), INTENT(OUT) :: flux_v     ! v wind tension (kg m/s)/(m**2 s) or Pascal
 !FC
-    REAL, DIMENSION(klon, klev, nbsrf), INTENT(INOUT) :: treedrg  ! tree drag (m)               
+    REAL, DIMENSION(klon, klev, nbsrf), INTENT(INOUT) :: treedrg  ! tree drag (m)     
+!AM heterogeneous continental sub-surfaces
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: tsurf_tersrf     ! surface temperature of continental sub-surfaces (K)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: qsurf_tersrf     ! surface specific humidity of continental sub-surfaces (kg/kg)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: tsurf_new_tersrf ! surface temperature of continental sub-surfaces (K)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: cdragm_tersrf    ! momentum drag coefficient of continental sub-surfaces (-)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: cdragh_tersrf    ! heat drag coefficient of continental sub-surfaces (-)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: swnet_tersrf     ! net shortwave radiation of continental sub-surfaces (W/m2)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: lwnet_tersrf     ! net longwave radiation of continental sub-surfaces (W/m2)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: fluxsens_tersrf  ! sensible heat flux of continental sub-surfaces (W/m2)               
+    REAL, DIMENSION(klon, nbtersrf), INTENT(INOUT) :: fluxlat_tersrf   ! latent heat flux of continental sub-surfaces (W/m2)               
+    REAL, DIMENSION(klon, nsoilmx, nbtersrf), INTENT(INOUT) :: tsoil_tersrf ! soil temperature of continental sub-surfaces (K)               
 #ifdef ISO        
     REAL, DIMENSION(niso,klon),   INTENT(OUT)       :: xtsol      ! water height in the soil (mm)
@@ -1050,4 +1075,7 @@
     ! dt_ds, tkt, tks, taur, sss on ocean points
     REAL :: missing_val
+    ! AM !
+    REAL, DIMENSION(klon) :: z0m_eff, z0h_eff, ratio_z0m_z0h_eff, albedo_eff
+    REAL, DIMENSION(klon, nbtersrf) :: z0h_tersrf
 #ifdef ISO
     REAL, DIMENSION(klon)       :: h1
@@ -1474,4 +1502,10 @@
     ENDDO
 
+    ! AM heterogeneous continental subsurfaces
+    ! compute time-independent effective surface parameters
+    IF (iflag_hetero_surf .GT. 0) THEN
+      albedo_eff = eff_surf_param(klon, nbtersrf, albedo_tersrf, frac_tersrf, 'ARI')
+    ENDIF
+
 ! Mean calculations of albedo
 !
@@ -1486,4 +1520,10 @@
      DO nsrf = 1, nbsrf
        DO i = 1, klon
+          ! AM heterogeneous continental sub-surfaces
+          IF (nsrf .EQ. is_ter .AND. iflag_hetero_surf .GT. 0) THEN
+            alb_dir(i,k,nsrf) = albedo_eff(i)
+            alb_dif(i,k,nsrf) = albedo_eff(i)
+          ENDIF
+          !
           alb_dir_m(i,k) = alb_dir_m(i,k) + alb_dir(i,k,nsrf) * pctsrf(i,nsrf)
           alb_dif_m(i,k) = alb_dif_m(i,k) + alb_dif(i,k,nsrf) * pctsrf(i,nsrf)
@@ -1883,4 +1923,27 @@
            speed(i) = SQRT(yu(i,1)**2+yv(i,1)**2)
         ENDDO
+!       
+        !!! AM heterogeneous continental subsurfaces
+        IF (nsrf .EQ. is_ter) THEN
+          ! compute time-dependent effective surface parameters (function of zgeo1) !! AM
+          IF (iflag_hetero_surf .GT. 0) THEN
+            DO i=1,klon
+              DO j=1,nbtersrf
+                IF (ratio_z0m_z0h_tersrf(i,j) .NE. 0.) THEN
+                  z0h_tersrf(i,j) = z0m_tersrf(i,j) / ratio_z0m_z0h_tersrf(i,j)
+                ELSE
+                  z0h_tersrf(i,j) = 0.
+                ENDIF
+              ENDDO
+            ENDDO
+            !
+            z0m_eff = eff_surf_param(klon, nbtersrf, z0m_tersrf, frac_tersrf, 'CDN', zgeo1/RG)
+            z0h_eff = eff_surf_param(klon, nbtersrf, z0h_tersrf, frac_tersrf, 'CDN', zgeo1/RG)
+            yz0m = z0m_eff
+            yz0h = z0h_eff
+            !
+          ENDIF
+        ENDIF
+!
         CALL cdrag(knon, nsrf, &
             speed, yt(:,1), yq(:,1), zgeo1, ypaprs(:,1), s_pblh, &
@@ -2425,5 +2488,7 @@
                yqsurf, ytsurf_new, y_dflux_t, y_dflux_q, &
                y_flux_u1, y_flux_v1, &
-               yveget,ylai,yheight   &
+               yveget,ylai,yheight, tsurf_tersrf, tsoil_tersrf, qsurf_tersrf, tsurf_new_tersrf, &
+               cdragm_tersrf, cdragh_tersrf, &
+               swnet_tersrf, lwnet_tersrf, fluxsens_tersrf, fluxlat_tersrf  &
 #ifdef ISO
          &      ,yxtrain_f, yxtsnow_f,yxt1, &
@@ -2432,5 +2497,7 @@
 #endif               
          &      )
- 
+
+          tsurf_tersrf(:,:) =  tsurf_new_tersrf(:,:) ! for next time step
+
 !FC quid qd yveget ylai yheight ne sont pas definit
 !FC  yveget,ylai,yheight, &
Index: /LMDZ6/trunk/libf/phylmd/phyaqua_mod.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phyaqua_mod.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/phyaqua_mod.f90	(revision 5627)
@@ -355,4 +355,12 @@
     alp_bl =0.
     treedrg(:,:,:)=0.
+    tsurf_tersrf(:,:) = 0.
+    qsurf_tersrf(:,:) = 0.
+    cdragm_tersrf(:,:) = 0.
+    cdragh_tersrf(:,:) = 0.
+    swnet_tersrf(:,:) = 0.
+    lwnet_tersrf(:,:) = 0.
+    fluxsens_tersrf(:,:) = 0.
+    fluxlat_tersrf(:,:) = 0.
 
     u10m = 0.
Index: /LMDZ6/trunk/libf/phylmd/phyetat0_mod.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phyetat0_mod.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/phyetat0_mod.f90	(revision 5627)
@@ -11,5 +11,5 @@
 
   USE clesphys_mod_h
-  USE dimphy, only: klon, zmasq, klev
+  USE dimphy, only: klon, zmasq, klev, nbtersrf, nbtsoildepths
   USE iophy, ONLY : init_iophy_new
   USE ocean_cpl_mod,    ONLY : ocean_cpl_init
@@ -30,5 +30,9 @@
        zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl, u10m, v10m, treedrg, &
        ale_wake, ale_bl_stat, ds_ns, dt_ns, delta_sst, delta_sal, dter, dser, &
-       dt_ds, ratqs_inter_
+       dt_ds, ratqs_inter_, frac_tersrf, z0m_tersrf, ratio_z0m_z0h_tersrf, &
+       albedo_tersrf, beta_tersrf, inertie_tersrf, alpha_soil_tersrf, &
+       period_tersrf, hcond_tersrf, tsurfi_tersrf, tsoili_tersrf, tsoil_depth, &
+       qsurf_tersrf, tsurf_tersrf, tsoil_tersrf, tsurf_new_tersrf, cdragm_tersrf, &
+       cdragh_tersrf, swnet_tersrf, lwnet_tersrf, fluxsens_tersrf, fluxlat_tersrf
 !FC
   USE geometry_mod,     ONLY: longitude_deg, latitude_deg
@@ -44,4 +48,5 @@
   use netcdf, only: missing_val_netcdf => nf90_fill_real
   use config_ocean_skin_m, only: activate_ocean_skin
+  USE surf_param_mod, ONLY: average_surf_var, interpol_tsoil !AM
   USE dimsoil_mod_h, ONLY: nsoilmx
   USE yomcst_mod_h
@@ -386,4 +391,56 @@
   ENDIF
 
+  IF (iflag_hetero_surf .GT. 0) THEN
+    found=phyetat0_srf(frac_tersrf,"frac_tersrf","fraction of continental sub-surfaces",0.)
+    found=phyetat0_srf(z0m_tersrf,"z0m_tersrf","roughness length for momentum of continental sub-surfaces",0.)
+    found=phyetat0_srf(ratio_z0m_z0h_tersrf,"ratio_z0m_z0h_tersrf","ratio of heat to momentum roughness length of continental sub-surfaces",0.)
+    found=phyetat0_srf(albedo_tersrf,"albedo_tersrf","albedo of continental sub-surfaces",0.)
+    found=phyetat0_srf(beta_tersrf,"beta_tersrf","evapotranspiration coef of continental sub-surfaces",0.)
+    found=phyetat0_srf(inertie_tersrf,"inertie_tersrf","soil thermal inertia of continental sub-surfaces",0.)
+    found=phyetat0_srf(hcond_tersrf,"hcond_tersrf","heat conductivity of continental sub-surfaces",0.)
+    found=phyetat0_srf(tsurfi_tersrf,"tsurfi_tersrf","initial surface temperature of continental sub-surfaces",0.)
+    !
+    ! Check if the sum of the sub-surface fractions is equal to 1
+    DO it=1,klon
+      IF (SUM(frac_tersrf(it,:)) .NE. 1.) THEN
+        PRINT*, 'SUM(frac_tersrf) = ', SUM(frac_tersrf(it,:))
+        CALL abort_physic('conf_phys', 'the sum of fractions of heterogeneous land subsurfaces must be equal &
+                          & to 1 for iflag_hetero_surf = 1 and 2',1)
+      ENDIF
+    ENDDO
+    !
+    ! Initialisation of surface and soil temperatures (potentially different initial temperatures between sub-surfaces)
+    DO iq=1,nbtersrf
+      DO it=1,klon
+        tsurf_tersrf(it,iq) = tsurfi_tersrf(it,iq)
+      ENDDO
+    ENDDO
+    !
+    DO isoil=1, nbtsoildepths 
+      IF (isoil.GT.99) THEN
+        PRINT*, "Trop de couches "
+        CALL abort_physic("phyetat0", "", 1)
+      ENDIF
+      WRITE(str2,'(i2.2)') isoil
+      found=phyetat0_srf(tsoil_depth(:,isoil,:),"tsoil_depth"//str2//"srf","soil depth of continental sub-surfaces",0.)
+      found=phyetat0_srf(tsoili_tersrf(:,isoil,:),"Tsoili"//str2//"srf","initial soil temperature of continental sub-surfaces",0.)
+      IF (.NOT. found) THEN
+        PRINT*, "phyetat0: Le champ <Tsoili"//str2//"> est absent"
+        PRINT*, "          Il prend donc la valeur de surface"
+        tsoili_tersrf(:, isoil, :) = tsurfi_tersrf(:, :)
+      ENDIF
+    ENDDO
+    !
+    tsoil_tersrf = interpol_tsoil(klon, nbtersrf, nsoilmx, nbtsoildepths, alpha_soil_tersrf, period_tersrf, &
+                   inertie_tersrf, hcond_tersrf, tsoil_depth, tsurf_tersrf, tsoili_tersrf)
+    !
+    ! initialise also average surface and soil temperatures
+    ftsol(:,is_ter) = average_surf_var(klon, nbtersrf, tsurf_tersrf, frac_tersrf, 'ARI')
+    DO k=1, nsoilmx
+      tsoil(:,k,is_ter) = average_surf_var(klon, nbtersrf, tsoil_tersrf(:,k,:), frac_tersrf, 'ARI')
+    ENDDO
+    !
+  ENDIF ! iflag_hetero_surf > 0
+
   endif ! iflag_physiq <= 1
 
Index: /LMDZ6/trunk/libf/phylmd/phyredem.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phyredem.f90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/phyredem.f90	(revision 5627)
@@ -34,5 +34,11 @@
                                 du_gwd_rando, du_gwd_front, u10m, v10m, &
                                 treedrg, solswfdiff, delta_sal, ds_ns, dt_ns, &
-                                delta_sst, ratqs_inter_, dter, dser, dt_ds
+                                delta_sst, ratqs_inter_, dter, dser, dt_ds,  &
+                                frac_tersrf, z0m_tersrf, ratio_z0m_z0h_tersrf, &
+                                albedo_tersrf, beta_tersrf, inertie_tersrf,  &
+                                hcond_tersrf, tsurfi_tersrf, tsoili_tersrf, tsoil_depth, &
+                                qsurf_tersrf, tsurf_tersrf, tsoil_tersrf, tsurf_new_tersrf, &
+                                cdragm_tersrf, cdragh_tersrf, &
+                                swnet_tersrf, lwnet_tersrf, fluxsens_tersrf, fluxlat_tersrf
 
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
@@ -189,5 +195,25 @@
 !  CALL put_field_srf2("treedrg","freinage arbres",treedrg(:,:,:))
     CALL put_field(pass,"treedrg_ter","freinage arbres",treedrg(:,:,is_ter))
-
+!AM
+    CALL put_field_srf1(pass,"frac_tersrf","fraction sous surface", frac_tersrf(:,:))
+    CALL put_field_srf1(pass,"z0m_tersrf","rugosite sous surface", z0m_tersrf(:,:))
+    CALL put_field_srf1(pass,"ratio_z0m_z0h_tersrf","ratio rugosites sous surface", ratio_z0m_z0h_tersrf(:,:))
+    CALL put_field_srf1(pass,"albedo_tersrf","albedo sous surface", albedo_tersrf(:,:))
+    CALL put_field_srf1(pass,"beta_tersrf","beta sous surface", beta_tersrf(:,:))
+    CALL put_field_srf1(pass,"inertie_tersrf","inertie sous surface", inertie_tersrf(:,:))
+    CALL put_field_srf1(pass,"hcond_tersrf","conductivité thermique sous surface", hcond_tersrf(:,:))
+    CALL put_field_srf1(pass,"tsurfi_tersrf","temperature surface sous surface initiale", tsurfi_tersrf(:,:))
+    CALL put_field_srf2(pass,"Tsoili","temperature sol sous surface initiale", tsoili_tersrf(:,:,:))
+    CALL put_field_srf2(pass,"tsoil_depth","profondeur temperature sol sous surface", tsoil_depth(:,:,:))
+    CALL put_field_srf1(pass,"qsurf_tersrf","humidite surface sous surface", qsurf_tersrf(:,:))
+    CALL put_field_srf1(pass,"tsurf_tersrf","temperature surface sous surface", tsurf_tersrf(:,:))
+    CALL put_field_srf1(pass,"tsurf_new_tersrf","temperature surface sous surface", tsurf_new_tersrf(:,:))
+    CALL put_field_srf1(pass,"cdragm_tersrf","coeff trainee quantite mouvement sous surface", cdragm_tersrf(:,:))
+    CALL put_field_srf1(pass,"cdragh_tersrf","coeff trainee chaleur sous surface", cdragh_tersrf(:,:))
+    CALL put_field_srf1(pass,"swnet_tersrf","shortwave net sous surface", swnet_tersrf(:,:))
+    CALL put_field_srf1(pass,"lwnet_tersrf","longwave net sous surface", lwnet_tersrf(:,:))
+    CALL put_field_srf1(pass,"fluxsens_tersrf","flux sensible sous surface", fluxsens_tersrf(:,:))
+    CALL put_field_srf1(pass,"fluxlat_tersrf","flux latent sous surface", fluxlat_tersrf(:,:))
+    CALL put_field_srf2(pass,"tsoil_tersrf","temperature sol sous surface", tsoil_tersrf(:,:,:))
 
     CALL put_field_srf1(pass,"QS"  , "Humidite",qsurf(:,:))
